/*
Global varibles/functions
	background.js
		cmdStatus
	stateExtractor.js
		performAction();
*/


var currentLevel = 1;
//indicate if current level has been increased due to 'game won' state
//if true, do not increase currentlevel
//else currentlevel++
var gameWonProcessed = true;

//A strategy description of choosing a target
var targetPointRequest;

//A possible target for existence test
var targetForTest;

//current target point
var targetPt;

//A strategy description of adjusting a target
var adjustTargetRequest;

var tapInterval;

//high or low trajectory
var trajectory;

//a cache of the current scene. It will be updated after one shot has been made
var cachedColour = null;

//how many times in a row that no sling shot is detected in "playing" state
var noSlingTimes = 0;

//if undesired segmentation appears (e.g. no sling in playing mode or no bird on sling), slightly change zooming level
var adjustZoomTimes = 0;


//if a level has been jumped over due to no slling detection
//avoid multiple clicks on "pause" and "back to level selection"
var jumpedLevel = false;

//if a shot is made after the recent screenshot
var shotMade = false;


function loadLevel(state){
	
}

function setTraj(request){
	if(request.trajectory == null){
		console.warn("trajectory info not found in snap request");
		console.warn("set trajectory to random...");
		var r = Math.floor(Math.random() * 2);
		if(r == 0){
			trajectory = "high";
			console.log("trajectory is set to high...");
		}
		else{
			trajectory = "low";
			console.log("trajectory is set to low...");
		}
		
	}
	else{
	
		console.log("set trajectory to "  + request.trajectory);
		trajectory = request.trajectory;
	
	}
	
	cmdStatus = 'completed';
	
}

function testTarget(request,pigs,blocks,sling,colour){
  var targetObj;
	var targetPoint;
	if(request.targetType == 'pig'){
		var pigDescription = request.targetDescription.pig;
		//console.log('pig description ' + pigDescription);
		if(pigDescription != null){
			targetObj = getPig(pigDescription, pigs, sling, colour);
			if(targetObj != null){
				//targetPoint = new Point(targetObj.centreX, targetObj.centreY);
				console.log(pigDescription.position + ' ' + pigDescription.reachability + ' pig: ' + targetObj.x + ' ' + targetObj.y + ' found');
        return true;
			}
			else{
				console.log('no target pig found...');
        return false;
			}
		}
		else{
			return false;
		}
	}
	
	else if(request.targetType == 'supporter'){
		var pigDescription = request.targetDescription.pig;
		var supporterPosition = request.targetDescription.supporter.position;
		var supporterType = request.targetDescription.supporter.type;
    var supporterReachability = request.targetDescription.supporter.reachability;
		
    
		var targetPig = getPig(pigDescription, pigs,sling,colour);
		if(targetPig != null){
			var supporters = getSupporters(targetPig,blocks);
      
      var selectedBlocks = getBlockByType(supporters,supporterType);
      supporters = getBlockByReachability(selectedBlocks,supporterReachability,sling,colour);
      
			if(supporters.length > 0){
				targetObj = getSpecficBlock(supporterPosition, supporters);
				targetPoint = new Point(targetObj.centreX, targetObj.centreY);
				
				console.log("found " + supporterPosition + " supporter at "+ targetPoint.x + ',' + targetPoint.y  +
          " of the " + pigDescription.position + ' ' + pigDescription.reachability + ' pig ' + targetPig.x + ' ' + targetPig.y);
        return true;
			}
			else{
				return false;
			}
		}
		else{
			console.warn(pigDescription + " not found");
      return false;
		}
	}
	
	else if(request.targetType == 'block'){
		var blockPosition = request.targetDescription.block.position;
		var blockType = request.targetDescription.block.type;
		var blockReachability = request.targetDescription.block.reachability;
    var selectedBlocks = getBlockByType(blocks,blockType);
    selectedBlocks = getBlockByReachability(selectedBlocks,blockReachability,sling,colour);
        
		targetObj = getSpecficBlock(blockPosition, selectedBlocks);
		if(!targetObj){
			console.log('no target block found...');	
      return false;
		}
		else{
      console.log("found " + blockPosition + ' ' + blockType + ' ' + blockReachability + " block at "+ targetObj.x + ',' + targetObj.y);
			return true;
		}
	}
	
	else{
		return false;
	}
}

function setTarget(request,pigs,blocks,sling,colour){
	var targetObj;
	var targetPoint;
	if(request.targetType == 'pig'){
		var pigDescription = request.targetDescription.pig;
		//console.log('pig description ' + pigDescription);
		if(pigDescription != null){
			targetObj = getPig(pigDescription, pigs, sling, colour);
			if(targetObj != null){
				targetPoint = new Point(targetObj.centreX, targetObj.centreY);
				console.log('set target to ' + pigDescription + ' pig: ' + targetPoint.x + ' ' + targetPoint.y);
			}
			else{
				console.log('no target pig found...');
			}
		}
		else{
			targetObj = randomPig();
			if(targetObj != null){
				targetPoint = new Point(targetObj.centreX, targetObj.centreY);
				console.log('set target to a random pig ' + targetPoint.x + ' ' + targetPoint.y);
			}
			
			else{
				console.warn('No pig found, target not set!');
			}
		}
	}
	
	else if(request.targetType == 'supporter'){
		var pigDescription = request.targetDescription.pig;
		var supporterPosition = request.targetDescription.supporter.position;
		var supporterType = request.targetDescription.supporter.type;
    var supporterReachability = request.targetDescription.supporter.reachability;
		
    
		var targetPig = getPig(pigDescription, pigs,sling,colour);
		if(targetPig != null){
			var supporters = getSupporters(targetPig,blocks);
      
      var selectedBlocks = getBlockByType(supporters,supporterType);
      supporters = getBlockByReachability(selectedBlocks,supporterReachability,sling,colour);
      
			if(supporters.length > 0){
				targetObj = getSpecficBlock(supporterPosition, supporters);
				targetPoint = new Point(targetObj.centreX, targetObj.centreY);
				
				console.log("set target to the " + supporterPosition + " supporter of the " + pigDescription + 'pig');
			}
			else{
				targetObj = targetPig;
				if(targetObj != null){
					targetPoint = new Point(targetObj.centreX, targetObj.centreY);
							
					console.warn("no supporter of the " + pigDescription + " pig is found");
					console.log("set target to the " + pigDescription + 'pig');
				}
			}
		}
		else{
			console.warn(pigDescription + " not found, target not set!");
		}
	}
	
	else if(request.targetType == 'block'){
		var blockPosition = request.targetDescription.block.position;
		var blockType = request.targetDescription.block.type;
		var blockReachability = request.targetDescription.block.reachability;
    var selectedBlocks = getBlockByType(blocks,blockType);
    selectedBlocks = getBlockByReachability(selectedBlocks,blockReachability,sling,colour);
        
		targetObj = getSpecficBlock(blockPosition, selectedBlocks);
		if(!targetObj){
			console.log('no target block found...');	
		}
		else{
			targetPoint = new Point(targetObj.centreX, targetObj.centreY);
			console.log("set target to the " + blockPosition + ' ' + blockType + " block");
		}
	}
	
	else{
		console.warn('Invalid target description :' + request + ' received');
		
		targetObj = randomPig();
		if(targetObj != null){
			console.log('set target to a random pig ' + targetPoint.x + ' ' + targetPoint.y);
			targetPoint = new Point(targetObj.centreX, targetObj.centreY);
		}
		
		else{
			console.warn('No pig found, target not set!');
		}
	}
	
	return targetPoint;
}

function getBlockByReachability(blocks,reachability,sling,colour){
  var selectedBlocks = new Array();
  //initialize trajectory planner
  var tp = new trajectoryPlanner();
 
  if(reachability == 'high_reachable'){

    for(var i = 0; i < blocks.length;i++){
      var tarPt = new Point(blocks[i].centreX, blocks[i].centreY);
      //calculate release point 
      //may include a low and a high trajectory, or only a low one.
      var releasePts = tp.estimateLaunchPoint(sling, tarPt);
      var releasePt;

      if(releasePts.length >1){
        releasePt = releasePts[1];
      }
      else{
        reachable = false;
        continue;
      }
      var trajectoryPts = tp.predictTrajectory(sling, releasePt);
      var reachable = true;
      for(var j = 0; j < trajectoryPts.length; j++){
        if(trajectoryPts[j].x >= tarPt.x - 6 || trajectoryPts[j].x < sling.x + sling.width)
          continue;
        var offset = (trajectoryPts[j].x + 840 * trajectoryPts[j].y) * 4;
        
        var compressedRBG =  ((colour[offset] & 0xe0) << 1) |
         ((colour[offset + 1] & 0xe0) >> 2) |
         ((colour[offset + 2] & 0xe0) >> 5);
        if(compressedRBG == 136 || compressedRBG == 72//terrian 
          || compressedRBG == 292 || compressedRBG == 365//stone
          || compressedRBG == 408 || compressedRBG == 481//wood
          || compressedRBG == 247//ice
          ){
            console.log('object with centre ' + tarPt.x + ' ' + tarPt.y + ' is not reachable with ' + trajectory+ ' trajectory');  
            console.log('it will be blocked by ' + trajectoryPts[j].x + ' ' + trajectoryPts[j].y);  
            reachable = false;
            break;
          }
      }
      
      if(reachable){
        selectedBlocks.push(blocks[i]);
      }
    } 
  }
  else if(reachability == 'low_reachable'){
    for(var i = 0; i < blocks.length;i++){
      var tarPt = new Point(blocks[i].centreX, blocks[i].centreY);
      //calculate release point 
      //may include a low and a high trajectory, or only a low one.
      var releasePts = tp.estimateLaunchPoint(sling, tarPt);
      var releasePt;
      releasePt = releasePts[0];

      var trajectoryPts = tp.predictTrajectory(sling, releasePt);
      var reachable = true;
      for(var j = 0; j < trajectoryPts.length; j++){
        if(trajectoryPts[j].x >= tarPt.x - 6 || trajectoryPts[j].x < sling.x + sling.width)
          continue;
        var offset = (trajectoryPts[j].x + 840 * trajectoryPts[j].y) * 4;
        
        var compressedRBG =  ((colour[offset] & 0xe0) << 1) |
         ((colour[offset + 1] & 0xe0) >> 2) |
         ((colour[offset + 2] & 0xe0) >> 5);
        if(compressedRBG == 136 || compressedRBG == 72//terrian 
          || compressedRBG == 292 || compressedRBG == 365//stone
          || compressedRBG == 408 || compressedRBG == 481//wood
          || compressedRBG == 247//ice
          ){
            console.log('object with centre ' + tarPt.x + ' ' + tarPt.y + ' is not reachable with ' + trajectory+ ' trajectory');  
            console.log('it will be blocked by ' + trajectoryPts[j].x + ' ' + trajectoryPts[j].y);  
            reachable = false;
            break;
          }
      }
      
      if(reachable){
        selectedBlocks.push(blocks[i]);
      }
    } 
  }
  
  else
    selectedBlocks = blocks;
  return selectedBlocks;
}

function getBlockByType(blocks,type){
	var selectedBlocks = new Array();
	
	if(type === 'all'){
		selectedBlocks = blocks;
	}
	
	else if(type === 'wood'){
    for(var i = 0; i < blocks.length; i++){
      if(blocks[i].type == 'wood'){
        selectedBlocks.push(blocks[i]);
      }
    }
	}
	
	else if(type === 'ice'){
		for(var i = 0; i < blocks.length; i++){
      if(blocks[i].type == 'ice'){
        selectedBlocks.push(blocks[i]);
      }
    }
	}
	
	else if(type === 'stone'){
		for(var i = 0; i < blocks.length; i++){
      if(blocks[i].type == 'stone'){
        selectedBlocks.push(blocks[i]);
      }
    }
	}
	
	else if(type === 'wood_stone'){
    for(var i = 0; i < blocks.length; i++){
      if(blocks[i].type == 'wood' ||blocks[i].type == 'stone'){
        selectedBlocks.push(blocks[i]);
      }
    }
	}
	
	else if(type === 'wood_ice'){
    for(var i = 0; i < blocks.length; i++){
      if(blocks[i].type == 'wood' ||blocks[i].type == 'ice'){
        selectedBlocks.push(blocks[i]);
      }
    }
	}
	
	else if(type === 'ice_stone'){
    for(var i = 0; i < blocks.length; i++){
      if(blocks[i].type == 'ice' ||blocks[i].type == 'stone'){
        selectedBlocks.push(blocks[i]);
      }
    }
	}
  
  else{
		selectedBlocks = blocks;
	}
	return selectedBlocks;
}

function getPig(pigDescription,pigs,sling,colour){
	var targetObj;
  var position = pigDescription.position;
  var reachability = pigDescription.reachability;
  if(reachability == 'high_reachable' || reachability == 'low_reachable' ){
    pigs = getBlockByReachability(pigs,reachability,sling,colour);
  }
  
	if(position == 'leftmost'){
		targetObj = getLeftmostObj(pigs);
	}
	
	else if(position == 'rightmost'){
		targetObj = getRightmostObj(pigs);
	}
	
	else if(position == 'highest'){
		targetObj = getHighestObj(pigs);
	}
	
	else if(position == 'lowest'){
		targetObj = getLowestObj(pigs);
	}
	
	else if(position == 'random'){
		targetObj = getRandomObj(pigs);

	}
  
  else{
    targetObj = getRandomObj(pigs);
  }
	
	return targetObj;
}

function getSpecficBlock(blockPosition,blocks){
	var targetObj;
	if(blockPosition == 'leftmost'){
		targetObj = getLeftmostObj(blocks);
	}
	
	else if(blockPosition == 'rightmost'){
		targetObj = getRightmostObj(blocks);
	}
	
	else if(blockPosition == 'highest'){
		targetObj = getHighestObj(blocks);
	}
	
	else if(blockPosition == 'lowest'){
		targetObj = getLowestObj(blocks);
	}
	
	else if(blockPosition == 'random'){
		targetObj = getRandomObj(blocks);

	}
  
  else{
  	targetObj = getRandomObj(blocks);
  }
	
	return targetObj;
}

function getRandomObj(objs){
	var index = Math.floor(Math.random() * objs.length);
	return objs[index];
}

function getLeftmostObj(objs){
	var sortedObjs = heapSort(objs, 'x');
	return sortedObjs[sortedObjs.length-1];
	
}

function getRightmostObj(objs){
	var sortedObjs = heapSort(objs, 'x');
	return sortedObjs[0];
}

function getHighestObj(objs){
	var sortedObjs = heapSort(objs, 'y');
	return sortedObjs[sortedObjs.length-1];
}

function getLowestObj(objs){
	var sortedObjs = heapSort(objs, 'y');
	return sortedObjs[0];
}

function getSupporters(target,objs){
  var sortedObjs = heapSort(objs, 'y');
	var supporters = new Array();
	// Loop through the potential supporters
	for (var i = sortedObjs.length-1 ; i >= 0; i--) {
    //console.log('evaluating supporting relation: obj ' + sortedObjs[i].x + ' ' + sortedObjs[i].y + ' height ' + sortedObjs[i].height + ' width ' + sortedObjs[i].width);
		if (isSupporter(target, sortedObjs[i],supporters)){
      //console.log('supporting');
			supporters.push(sortedObjs[i]);
    }
    else{
      //console.log('not supporting');
    }
	}
	return supporters;
}

// If o1 supports o2, return true
function isSupporter(o2, o1,supporters) {
	var gapThreshold = 5;
	var ex_o1 = o1.x + o1.width;
	var ex_o2 = o2.x + o2.width;

	var ey_o2 = o2.y + o2.height;
	
	if ((Math.abs(ey_o2 - o1.y) < gapThreshold)
			&& !(o2.x > ex_o1 || o1.x > ex_o2)){
		return true;
	}
	else{
    for(var i = 0; i < supporters.length; i++){
      var ex_oSupp = supporters[i].x + supporters[i].width;
      var ey_oSupp = supporters[i].y + supporters[i].height;
      if ((Math.abs(o1.y - ey_oSupp) < gapThreshold)
			&& !(o1.x > ex_oSupp || supporters[i].x > ex_o1)){
        
        return true;
      }
    }
		return false;
	}
}

function adjustTarget(request,targetPoint){
	if(request){
		var dx = request.x;
		var dy = request.y;
		
		if(isNumber(dx) && isNumber(dy)){
			targetPoint.x += parseInt(dx);
			targetPoint.y += parseInt(dy);
			
			console.log('adjust target by ' + dx + ' ' + dy);
			
			return targetPoint;
		}
		
		else{
			console.warn('illegal parameters for adjust target');
			return targetPoint;
		}
	}
}

function setTapInterval(request){
	if(isNumber(request.tapInterval) && request.tapInterval >= 0 && request.tapInterval <= 100){
		console.log("set tap time to "  + request.tapInterval);
		tapInterval = request.tapInterval;
	}
	
	else{
		console.warn("tapInterval not found or invalid tapInterval in snap request : " + request.tapInterval);
		console.warn("no tap will be performed...");
		tapInterval = 0;
	}
	
	cmdStatus = 'completed';
}

function getBirdType(){

  if(!shotMade && cachedColour != null){
    var vision = new Vision(cachedColour, 840, 480);
    var sling = vision.findSlingshotMBR();
    if(sling!=null){
      var currentBird;
      var	birdY = 10000;
      var redBirds = vision.findRedBirds();
      var yellowBirds = vision.findYellowBirds();
      var blueBirds = vision.findBlueBirds();
      var whiteBirds = vision.findWhiteBirds();
      var blackBirds = vision.findBlackBirds();
      
      //the rectangle that a bird may appear on the sling
      var birdRegion = new Rectangle(Math.floor(sling.x),Math.floor(sling.y),Math.floor(sling.width),Math.floor(sling.height/2));
      var histogram = vision.histogram(birdRegion);
      
      //red bird
      if(histogram[385] != 0){
        currentBird = 'red';
      }
      
      //blue bird
      else if(histogram[238] != 0){
        currentBird = 'blue';
      }
      
      //yellow bird
      else if(histogram[497] != 0){
        currentBird = 'yellow';
      }
      
      //white bird
      else if(histogram[490] != 0){
        currentBird = 'white';
      }
      
      //black bird
      else if(histogram[488] != 0){
        currentBird = 'black';
      }
      
      if(!currentBird){
        birdType = 'unknown';

      }
      else{
        birdType = currentBird;
        //adjustZoomTimes = 0;
      }
      console.log('Current Bird: ' + birdType	);
      return;
    }
  }

	var img = new Image();
	//take the first screenshot and try to find the slingshot
	img.onload = function(){
		var canvas;
		var context;
		fullyZoomOut();
		setTimeout(function(){
			for(var i = 0; i < adjustZoomTimes; i++){
				zoomIn();
			}
		},2000);
		
		setTimeout(function(){
		
			if(canvas == null){
				canvas = $('<canvas />').attr('height', 480 + 'px').attr('width', 840 + 'px')[0];
				context = canvas.getContext('2d');
			}	
			context.clearRect (0, 0, 840, 480);
			
			context.drawImage(img,0,0); //with offset 0,0
			var colour = context.getImageData(0, 0, img.width, img.height).data;
			var vision = new Vision(colour, img.width, img.height);
			var sling = vision.findSlingshotMBR();
			
			//sling found 
			if(sling != null){
				//set jumpedLevel back to false if a sling is detected
				jumpedLevel = false;
				
				noSlingTimes = 0;
				var img2 = new Image();
				var canvas2;
				var context2;
				//take the second screenshot to test if the scale is changed
				img2.onload = function(){
				
				//	fullyZoomIn();
				//	for(var i = 0; i < adjustZoomTimes; i++){
				//		zoomOut();
				//	}
					if(canvas2 == null){
						canvas2 = $('<canvas />').attr('height', 480 + 'px').attr('width', 840 + 'px')[0];
						context2 = canvas2.getContext('2d');
					}	
					context2.clearRect (0, 0, 840, 480);
					context2.drawImage(img2,0,0); //with offset 0,0
					var colour = context2.getImageData(0, 0, img2.width, img2.height).data;
					var vision = new Vision(colour, img2.width, img2.height);
					var slingNew = vision.findSlingshotMBR();
					
					//slingshot found
					if(slingNew != null){
						noSlingTimes = 0;
						var scale_diff = Math.pow((sling.width - slingNew.width),2) +  Math.pow((sling.height - slingNew.height),2);
						//slingshot scale is not changed, perform the shot
						if(scale_diff  < 25){
              shotMade = false;
              cachedColour = colour;
							console.log("sling scale remains stable, retrieving bird on sling");

							var currentBird;
							var	birdY = 10000;
							var redBirds = vision.findRedBirds();
							var yellowBirds = vision.findYellowBirds();
							var blueBirds = vision.findBlueBirds();
							var whiteBirds = vision.findWhiteBirds();
							var blackBirds = vision.findBlackBirds();
							
							//the rectangle that a bird may appear on the sling
							var birdRegion = new Rectangle(Math.floor(slingNew.x),Math.floor(slingNew.y),Math.floor(slingNew.width),Math.floor(slingNew.height/2));
							var histogram = vision.histogram(birdRegion);
							
							//red bird
							if(histogram[385] != 0){
								currentBird = 'red';
							}
							
							//blue bird
							else if(histogram[238] != 0){
								currentBird = 'blue';
							}
							
							//yellow bird
							else if(histogram[497] != 0){
								currentBird = 'yellow';
							}
							
							//white bird
							else if(histogram[490] != 0){
								currentBird = 'white';
							}
							
							//black bird
							else if(histogram[488] != 0){
								currentBird = 'black';
							}
							
							if(!currentBird){
								birdType = 'unknown';

							}
							else{
								birdType = currentBird;
								adjustZoomTimes = 0;
							}
							console.log('Current Bird: ' + birdType	);
							
						}			
						
						//slingshot changed, redo the screenshot and segmentation
						else{
							console.warn('slingshot scale is changed, redo the screenshot and segmentation...');
							//re-segment and perform a shot
							//getBirdTypeProcedure();
							birdType = 'failed';
						}
					}
					
					//sling not found
					else{
						console.log('sling not found, redo screenshot and segmentation!');	
			
						chrome.tabs.sendMessage(abTabId, {command:"screenshot"}, function(response) {
				
							var gameStateProcessed = false;
							var screenshot = new Image();
							screenshot.onload = function(){
								if(!jumpedLevel){	
									noSlingTimes++;	
									console.log("noSlingTimes " + noSlingTimes);
									if(noSlingTimes > 1){
										//jump to the next level
										console.warn("slightly zoom in to find sling...");
										//currentLevel++;
										//performAction(screenshot,new function(){});
										adjustZoomTimes++;
										noSlingTimes = 0;
									}	
								}
								//check current game state and take corresponding action
								//performAction(screenshot,getBirdType);
								birdType = 'failed';
							}						
							screenshot.src = response.data;
						});
					}

					
				}
				
				chrome.tabs.sendMessage(abTabId, {command:"screenshot"}, function(response) {
				//	console.log('agent.js: response from content script ' + response.data);
					var imageStr = response.data;
					img2.src = imageStr;
				});	
				
				
			}
			
			else{
				console.log('sling not found, redo screenshot and segmentation!');
				//while(gameState != ABState.Playing){			
				chrome.tabs.sendMessage(abTabId, {command:"screenshot"}, function(response) {
				
					var gameStateProcessed = false;
					var screenshot = new Image();
					screenshot.onload = function(){				
						if(!jumpedLevel){	
							noSlingTimes++;	
							console.log("noSlingTimes " + noSlingTimes);
							if(noSlingTimes > 1){
								//jump to the next level
								console.warn("slightly zoom in to find sling...");
								//zoomOut();
								adjustZoomTimes++;
								noSlingTimes = 0;
							}	
						}
						//check current game state and take corresponding action
						//performAction(screenshot,getBirdType);
						birdType = 'failed';
					}
					
					screenshot.src = response.data;
				});
			}
		},2000 + 200 * adjustZoomTimes);
				
	}
	
	chrome.tabs.sendMessage(abTabId, {command:"screenshot"}, function(response) {
		if(response.data){
			var imageStr = response.data;
			img.src = imageStr;
		}
		else{
			//getBirdTypeProcedure();
			birdType = 'failed';
		}
	});	
	
}

function getTargetStatus(){
  
  if(!shotMade && cachedColour != null){
    var vision = new Vision(cachedColour, 840, 480);
    var sling = vision.findSlingshotMBR();
    var woodObjs = vision.findWood();
    var stoneObjs = vision.findStones();
    var iceObjs = vision.findIce();
    var pigs = vision.findPigs();
    
    var blocks = stoneObjs.concat(iceObjs);
    blocks = blocks.concat(woodObjs);
    
    if(sling != null){
      if(testTarget(targetForTest,pigs,blocks,sling,cachedColour)){
        targetStatus =  'existing';
        console.log('target exists');  
      }
      else{  
        targetStatus =  'empty';
        console.log('target not exists');  
      }  
      return;  
    }      
  }
  
    var img = new Image();
    //take the first screenshot and try to find the slingshot
    img.onload = function(){
      var canvas;
      var context;
      fullyZoomOut();
      setTimeout(function(){
        for(var i = 0; i < adjustZoomTimes; i++){
          zoomIn();
        }
      },2000);
      
      setTimeout(function(){
      
        if(canvas == null){
          canvas = $('<canvas />').attr('height', 480 + 'px').attr('width', 840 + 'px')[0];
          context = canvas.getContext('2d');
        }	
        context.clearRect (0, 0, 840, 480);
        
        context.drawImage(img,0,0); //with offset 0,0
        var colour = context.getImageData(0, 0, img.width, img.height).data;
        var vision = new Vision(colour, img.width, img.height);
        var sling = vision.findSlingshotMBR();
        
        //sling found 
        if(sling != null){
          //set jumpedLevel back to false if a sling is detected
          jumpedLevel = false;
          
          noSlingTimes = 0;
          var img2 = new Image();
          var canvas2;
          var context2;
          //take the second screenshot to test if the scale is changed
          img2.onload = function(){
          
          //	fullyZoomIn();
          //	for(var i = 0; i < adjustZoomTimes; i++){
          //		zoomOut();
          //	}
            if(canvas2 == null){
              canvas2 = $('<canvas />').attr('height', 480 + 'px').attr('width', 840 + 'px')[0];
              context2 = canvas2.getContext('2d');
            }	
            context2.clearRect (0, 0, 840, 480);
            context2.drawImage(img2,0,0); //with offset 0,0
            var colour = context2.getImageData(0, 0, img2.width, img2.height).data;
            var vision = new Vision(colour, img2.width, img2.height);
            var slingNew = vision.findSlingshotMBR();
            
            //slingshot found
            if(slingNew != null){
              noSlingTimes = 0;
              var scale_diff = Math.pow((sling.width - slingNew.width),2) +  Math.pow((sling.height - slingNew.height),2);
              //slingshot scale is not changed, perform the shot
              if(scale_diff  < 25){
                shotMade = false;
                cachedColour = colour;
                console.log("sling scale remains stable, testing target...");

                var woodObjs = vision.findWood();
                var stoneObjs = vision.findStones();
                var iceObjs = vision.findIce();
                var pigs = vision.findPigs();
                
                var blocks = stoneObjs.concat(iceObjs);
                blocks = blocks.concat(woodObjs);
                
                if(testTarget(targetForTest,pigs,blocks,slingNew,colour)){
                  targetStatus =  'existing';
                  console.log('target exists');  
                }
                else{  
                  targetStatus =  'empty';
                  console.log('target not exists');  
                } 
                
                adjustZoomTimes = 0;
              }			
              
              //slingshot changed, redo the screenshot and segmentation
              else{
                console.warn('slingshot scale is changed, redo the screenshot and segmentation...');
                //re-segment and perform a shot
                targetStatus = 'failed';
              }
            }
            
            //sling not found
            else{
              console.log('sling not found, redo screenshot and segmentation!');	
        
              chrome.tabs.sendMessage(abTabId, {command:"screenshot"}, function(response) {
          
                var gameStateProcessed = false;
                var screenshot = new Image();
                screenshot.onload = function(){
                  if(!jumpedLevel){	
                    noSlingTimes++;	
                    console.log("noSlingTimes " + noSlingTimes);
                    if(noSlingTimes > 1){
                      //jump to the next level
                      console.warn("slightly zoom in to find sling...");
                      //currentLevel++;
                      //performAction(screenshot,new function(){});
                      adjustZoomTimes++;
                      noSlingTimes = 0;
                    }	
                  }
                  //check current game state and take corresponding action
                  //performAction(screenshot,getBirdType);
                  targetStatus = 'failed';
                }						
                screenshot.src = response.data;
              });
            }

            
          }
          
          chrome.tabs.sendMessage(abTabId, {command:"screenshot"}, function(response) {
          //	console.log('agent.js: response from content script ' + response.data);
            var imageStr = response.data;
            img2.src = imageStr;
          });	
          
          
        }
        
        else{
          console.log('sling not found, redo screenshot and segmentation!');
          //while(gameState != ABState.Playing){			
          chrome.tabs.sendMessage(abTabId, {command:"screenshot"}, function(response) {
          
            var gameStateProcessed = false;
            var screenshot = new Image();
            screenshot.onload = function(){				
              if(!jumpedLevel){	
                noSlingTimes++;	
                console.log("noSlingTimes " + noSlingTimes);
                if(noSlingTimes > 1){
                  //jump to the next level
                  console.warn("slightly zoom in to find sling...");
                  //zoomOut();
                  adjustZoomTimes++;
                  noSlingTimes = 0;
                }	
              }
              //check current game state and take corresponding action
              //performAction(screenshot,getBirdType);
              targetStatus = 'failed';
            }
            
            screenshot.src = response.data;
          });
        }
      },2000 + 200 * adjustZoomTimes);
          
    }
    
    chrome.tabs.sendMessage(abTabId, {command:"screenshot"}, function(response) {
      if(response.data){
        var imageStr = response.data;
        img.src = imageStr;
      }
      else{
        //getBirdTypeProcedure();
        targetStatus = 'failed';
      }
    });	
  
}

function shoot(){
  shotMade = true;
	var img = new Image();
	//take the first screenshot and try to find the slingshot
	img.onload = function(){
		var canvas;
		var context;
		fullyZoomOut();
		setTimeout(function(){
			for(var i = 0; i < adjustZoomTimes; i++){
				zoomIn();
			}
		},2000);
		//wait 2 seconds after zooming action
		setTimeout(function(){
			if(canvas == null){
				canvas = $('<canvas />').attr('height', 480 + 'px').attr('width', 840 + 'px')[0];
				context = canvas.getContext('2d');
			}	
			context.clearRect (0, 0, 840, 480);
			
			context.drawImage(img,0,0); //with offset 0,0
			var colour = context.getImageData(0, 0, img.width, img.height).data;
			var vision = new Vision(colour, img.width, img.height);
			var sling = vision.findSlingshotMBR();
			
			//sling found
			if(sling != null){
				//set jumpedLevel back to false if a sling is detected
				jumpedLevel = false;
				
				noSlingTimes = 0;
				var img2 = new Image();
				var canvas2;
				var context2;
				//take the second screenshot to test if the scale is changed
				img2.onload = function(){
				
				//	fullyZoomOut();
				//	for(var i = 0; i < adjustZoomTimes; i++){
				//		zoomIn();
				//	}
					if(canvas2 == null){
						canvas2 = $('<canvas />').attr('height', 480 + 'px').attr('width', 840 + 'px')[0];
						context2 = canvas2.getContext('2d');
					}	
					context2.clearRect (0, 0, 840, 480);
					context2.drawImage(img2,0,0); //with offset 0,0
					var colour = context2.getImageData(0, 0, img2.width, img2.height).data;
					var vision = new Vision(colour, img2.width, img2.height);
					var slingNew = vision.findSlingshotMBR();
					
					//slingshot found
					if(slingNew != null){
						noSlingTimes = 0;
						var scale_diff = Math.pow((sling.width - slingNew.width),2) +  Math.pow((sling.height - slingNew.height),2);
						//slingshot scale is not changed, perform the shot
						if(scale_diff  < 25){
							adjustZoomTimes = 0;
							console.log("sling scale remains stable, preparing for a shot");
							var woodObjs = vision.findWood();
							var stoneObjs = vision.findStones();
							var iceObjs = vision.findIce();
							var pigs = vision.findPigs();
							var redBirds = vision.findRedBirds();
							
              //if trajectory is not set, set to low
							if(!trajectory){
								trajectory = 'low';
							}
              
							var blocks = woodObjs;
              blocks.concat(stoneObjs);
              blocks.concat(iceObjs);
              //{wood:woodObjs,stone:stoneObjs,ice:iceObjs};
              if(!targetPointRequest){
                cmdStatus = 'completed';
                return;
              }
							console.log('target description ' + targetPointRequest.targetType);
							var tarPt = setTarget(targetPointRequest,pigs,blocks,sling,colour);
							
							//if target point is not set
							if(tarPt == null){
								if(pigs.length == 0){
									console.warn("no pig detected, redo segmentation...");
									
									//re-segment and perform a shot
									//ShootingSchema();
									//return;
									cmdStatus = 'failed';
								}
								
								else{
									console.warn("no target is set, pick a random pig...");
									var tarObj = getRandomObj(pigs); 
									tarPt = new Point(tarObj.centreX, tarObj.centreY);
									console.log('target set to ' + tarPt.x + ' ' + tarPt.y);
								}
							}
							console.log('target set to ' + tarPt.x + ' ' + tarPt.y);
							//adjust target point
							if(adjustTargetRequest){
								tarPt = adjustTarget(adjustTargetRequest,tarPt);
								console.log('target adjusted to ' + tarPt.x + ' ' + tarPt.y);
							}
							//initialize trajectory planner
							var tp = new trajectoryPlanner();
							
							//set global target point
							targetPt = tarPt
							//calculate release point 
							//may include a low and a high trajectory, or only a low one.
							var releasePts = tp.estimateLaunchPoint(sling, tarPt);

							//get reference point from slingshot
							var refPt = getReferencePoint(sling);
							

							
							//calculate drag offset from reference point to release point
							if(trajectory == 'low' || releasePts.length < 2 ){						
								if(releasePts[0] == null){
								
									console.warn("trajectory (low) not avaliable, trying to resegment");
									//ShootingSchema();
									//return;
									cmdStatus = 'failed';
								}
								var dx = releasePts[0].x - refPt.x;
								var dy = releasePts[0].y - refPt.y;
							}
							
							else{
								if(releasePts[1] == null){
									console.warn("trajectory (high) not avaliable, trying to resegment");
									//ShootingSchema();
									//return;
									cmdStatus = 'failed';
								}
								var dx = releasePts[1].x - refPt.x;
								var dy = releasePts[1].y - refPt.y;
							}
							//form a shot
							var shot = {command:"drag", data:{x : refPt.x, y: refPt.y, dx: dx, dy : dy}};
							
							//shoot!
							//only set cmdStatus to "completed" once a shot is actually been made
							chrome.tabs.sendMessage(abTabId, shot, function(response){cmdStatus = 'completed';});
							//console.log('refx ' + refPt.x + ' refy ' + refPt.y + ' dx ' + dx + ' dy ' + dy);	
							//console.log(' sling x'  + sling.x + ' sling.y ' + sling.y + ' sling w ' + sling.width + ' sling h ' + sling.height);
							//console.log('tar x ' + tarPt.x + ' tar y ' + tarPt.y);
						
							//if tap time not set, do not tap
							if(!tapInterval){
								tapInterval = 0;
							}
							//					
							var tap = tapInterval;
							
							//if tap interval is between 0 and 100
							//perform a tap, otherwise do not tap
							if(tap > 0 && tap <= 100 ){
								var tapTime; 
								if(trajectory == 'low' || releasePts.length < 2){
									tapTime = tp.getTapTime(sling, releasePts[0], tarPt, tap);
								}
								else{
									tapTime = tp.getTapTime(sling, releasePts[1], tarPt, tap);
								}
								console.log("tap time " + tapTime);
								

								//perform a tap
								setTimeout(function(){
									var tapCmd = {command:'click', data:{x:100,y:100}};
									chrome.tabs.sendMessage(abTabId, tapCmd, function(response){});
									cmdStatus = 'completed';
								}, tapTime);
							}
							
						}			
						
						//slingshot changed, redo the screenshot and segmentation
						else{
							console.warn('slingshot scale is changed, redo the screenshot and segmentation...');
							//re-segment and perform a shot
							//ShootingSchema();
							//return;
							cmdStatus = 'failed';
						}
					}
					
					//sling not found
					else{
						console.log('sling not found, redo screenshot and segmentation!');	
			
						chrome.tabs.sendMessage(abTabId, {command:"screenshot"}, function(response) {
				
							var gameStateProcessed = false;
							var screenshot = new Image();
							screenshot.onload = function(){
								if(!jumpedLevel){	
									noSlingTimes++;	
									console.log("noSlingTimes " + noSlingTimes);
									if(noSlingTimes > 1){
										//slightly zoom in to find sling
										console.warn("slightly zoom in to find sling...");
										//zoomIn();
										adjustZoomTimes++;
										//currentLevel++;
										//performAction(screenshot,new function(){});
										noSlingTimes = 0;
									}	
								}
								//check current game state and take corresponding action
								//performAction(screenshot,shoot);
								cmdStatus = 'failed';
							}						
							screenshot.src = response.data;
						});
					}

					
				}
				
				chrome.tabs.sendMessage(abTabId, {command:"screenshot"}, function(response) {
				//	console.log('agent.js: response from content script ' + response.data);
					var imageStr = response.data;
					img2.src = imageStr;
				});	
				
				
			}
			
			else{
				console.log('sling not found, redo screenshot and segmentation!');
				//while(gameState != ABState.Playing){			
				chrome.tabs.sendMessage(abTabId, {command:"screenshot"}, function(response) {
				
					var gameStateProcessed = false;
					var screenshot = new Image();
					screenshot.onload = function(){				
						if(!jumpedLevel){	
							noSlingTimes++;	
							console.log("noSlingTimes " + noSlingTimes);
							if(noSlingTimes > 1){
								//jump to the next level
								console.warn("slightly zoom in to find sling...");
								//currentLevel++;
								//performAction(screenshot,new function(){});
								adjustZoomTimes++;
								noSlingTimes = 0;
							}	
						}
						//check current game state and take corresponding action
						//performAction(screenshot,shoot);
						cmdStatus = 'failed';
					}
					
					screenshot.src = response.data;
				});
			}		
		},2000 + 200 * adjustZoomTimes);
		
		
	}
	chrome.tabs.sendMessage(abTabId, {command:"screenshot"}, function(response) {
		if(response.data){
			var imageStr = response.data;
			img.src = imageStr;
		}
		else{
			//ShootingSchema();
			//return;
			cmdStatus = 'failed';
		}
	});	
	

}

//fully zoom out
function fullyZoomOut(){
	console.log('fully zooming out');
	for(var i =0; i < 15; i++){
		chrome.tabs.sendMessage(abTabId, {command:"mousewheel",data:{delta:-1}}, function(response){});	
	}
}


//fully zoom in
function fullyZoomIn(){
	console.log('fully zooming in');
	for(var i =0; i < 15; i++){
		chrome.tabs.sendMessage(abTabId, {command:"mousewheel",data:{delta:1}}, function(response){});	
	}
}

//zoom out
function zoomOut(){
	console.log('zooming out');
	chrome.tabs.sendMessage(abTabId, {command:"mousewheel",data:{delta:-1}}, function(response){});	
}


//zoom in
function zoomIn(){
	console.log('zooming in');
	chrome.tabs.sendMessage(abTabId, {command:"mousewheel",data:{delta:1}}, function(response){});	
}

//TODO
function restartLevel(state){
	cmdStatus = 'completed';
}

function ShootingSchema(){
	//while(gameState != ABState.Playing){
	if(abTabId){
		chrome.tabs.sendMessage(abTabId, {command:"screenshot"}, function(response) {
			var gameStateProcessed = false;
			var screenshot = new Image();
			screenshot.onload = function(){
				//check current game state and take corresponding action
				performAction(screenshot,shoot);
			}
			if(!response){
				console.log('screenshot failed, command executing failed');
				cmdStatus = 'failed';
			}
			else{
				screenshot.src = response.data;
			}
		});
	}
	else{
		console.log('no angry birds window connected, command executing failed');
		cmdStatus = 'failed';
	}
}

function getBirdTypeProcedure(){		
	if(abTabId){
		chrome.tabs.sendMessage(abTabId, {command:"screenshot"}, function(response) {
			var gameStateProcessed = false;
			var screenshot = new Image();
			screenshot.onload = function(){
				console.log('agent.js: retrieving bird type');
				//check current game state and take corresponding action
				performAction(screenshot,getBirdType);
			}
			if(!response){
				console.log('screenshot failed, command executing failed');
				birdType = 'failed';
			}
			else{
				screenshot.src = response.data;
			}
		});
	}
	else{
		console.log('no angry birds window connected, command executing failed');
		birdType = 'failed';
	}
}

function testTargetSchema(){		
	if(abTabId){
		chrome.tabs.sendMessage(abTabId, {command:"screenshot"}, function(response) {
			var gameStateProcessed = false;
			var screenshot = new Image();
			screenshot.onload = function(){
				console.log('agent.js: retrieving bird type');
				//check current game state and take corresponding action
				performAction(screenshot,getTargetStatus);
			}
			if(!response){
				console.log('screenshot failed, command executing failed');
				targetStatus = 'failed';
			}
			else{
				screenshot.src = response.data;
			}
		});
	}
	else{
		console.log('no angry birds window connected, command executing failed');
		targetStatus = 'failed';
	}
}


//test if a input is a numeric value
function isNumber(n) {
	return !isNaN(parseFloat(n)) && isFinite(n);
}