//preload template images 
//for recognising game status
preloadTemplates();

//tab id of angry birds page
var abTabId; 

//indicates the processing state of a command
var cmdStatus = 'pending';

//bird type
var birdType = 'pending';

//the existence of quarying target
var targetStatus = 'pending';

var abConnected = false;

//indicates if a command is being sent repeatly due to late awareness of state change
var redundantCmdLock = false;

var gameState = ABState.Unknown;
var abOpened = false;

//send message to content-script for angry birds
function sendMessageToContent(request){
	//chrome.tabs.query({active: true}, function(tabs) {
	//	console.log('background.js: forwarded ' + request + ' to content page');
	//	console.log('background.js: double check tab id: ' + abTabId);
	var commands = request.command.split('/');
	var command = commands[0];
	
	if(command == 'shoot'){
		ShootingSchema();
	}
	
	else if(command == 'set_target'){
		
		var targetData;
		if(commands[1] == 'pig'){
			targetData = {targetType : 'pig', targetDescription : {pig:{position:commands[2],reachability:commands[3]}}};
		}
		
		else if(commands[1] == 'supporter'){
			targetData = {targetType : 'supporter', targetDescription : {pig:{position:commands[5],reachability:commands[6]},supporter:{position:commands[2],type:commands[3], reachability:commands[4]}}};	
		}
		
		else if(commands[1] == 'block'){
			targetData = {targetType : 'block', targetDescription : {block : {position:commands[2],type:commands[3],reachability:commands[4]}}};
		}
		
		targetPointRequest = targetData;
		cmdStatus = 'completed';
	}
  
  else if(command == 'test_target'){
		
		var targetData;
		if(commands[1] == 'pig'){
			targetData = {targetType : 'pig', targetDescription : {pig:{position:commands[2],reachability:commands[3]}}};
		}
		
		else if(commands[1] == 'supporter'){
			targetData = {targetType : 'supporter', targetDescription : {pig:{position:commands[5],reachability:commands[6]},supporter:{position:commands[2],type:commands[3], reachability:commands[4]}}};	
		}
		
		else if(commands[1] == 'block'){
			targetData = {targetType : 'block', targetDescription : {block : {position:commands[2],type:commands[3],reachability:commands[4]}}};
		}
		
    targetForTest = targetData;
		testTargetSchema();
	}
	
	else if(command == 'set_tap_point'){
		setTapInterval({tapInterval:commands[1]});
	}
	
	else if(command == 'adjust_target'){
		adjustTargetRequest = {x: commands[1], y :commands[2]};
		cmdStatus = 'completed';
	}
	
	else if(command == 'set_trajectory'){
		setTraj({trajectory:commands[1]});
	}
	
	else if(command == 'get_bird_type'){
		birdType = 'pending';
		getBirdTypeProcedure();
	}
	
	else if(command == 'process_after_shot'){
		
	}
	
	//});

}	
	
//listen to inner messages
chrome.runtime.onMessage.addListener(
	function(request, sender, sendResponse) {
		if(request.command == "angrybirds actived"){
			console.log("background.js: angrybirds tab id sent from angrybirds page, tab.id=", sender.tab.id);
			if(!abTabId){
				abTabId = sender.tab.id;
			}	
		}
		
		else if(request.command == "angrybirds closed" && sender.tab.id === abTabId){
			console.log("background.js: angrybirds closed, tab.id set to null");
			abTabId = null;
		}
		
		else if(request.command == "setLevel"){
			currentLevel = request.level;
		}
		else{
			console.log("background.js: command received : ", request.command);
			sendResponse({feedback: "received unknown command " + request.command});
		}
	}
)	


//listen to message(command) from SNAP!  	
chrome.runtime.onMessageExternal.addListener(
  function(request, sender, sendResponse) {
	if(!abOpened && abTabId == null){
		abOpened = true;
		if (confirm("No angrybirds window is connected\nDo you want to open one?") == true) {
			//abOpened = true;
			var abUrl = "http://chrome.angrybirds.com";
			chrome.windows.create({ url: abUrl });
		}
		else {
			//abOpened = true;
		}
	}


	
	if(request.command == 'checkState'){
		if(!abTabId){
			cmdStatus = 'failed';
			birdType = 'failed';
      targetStatus = 'failed';
      
			console.log('background.js: no AB connection!');
			sendResponse({feedback: 'no_connection'});
		}
		else{
			sendResponse({feedback: cmdStatus});
			console.log('background.js: received command ' + request.command);
		}
	}
	
	else if(request.command == 'getBird'){
		if(!abTabId){
			cmdStatus = 'failed';
			birdType = 'failed';
      targetStatus = 'failed';
      
			console.log('background.js: no AB connection!');
			sendResponse({feedback: 'no_connection'});
		}
		else {
			sendResponse({feedback: birdType});
			console.log('background.js: received command ' + request.command);
		}
	}
  
  else if(request.command == 'getTargetStatus'){
		if(!abTabId){
			cmdStatus = 'failed';
			birdType = 'failed';
      targetStatus = 'failed';
			
      console.log('background.js: no AB connection!');
			sendResponse({feedback: 'no_connection'});
		}
		else {
			sendResponse({feedback: targetStatus});
			console.log('background.js: received command ' + request.command);
		}
	}
  
	else {
		if(cmdStatus == 'pending' && birdType == 'pending' && targetStatus == 'pending' && redundantCmdLock){
			sendResponse({feedback: 'command: ' + request.command + ' not processed due to redundancy'});
			console.log('background.js: received command ' + request.command);
			console.log('background.js: command: ' + request.command + ' not processed due to redundancy');
		}
		
		else if(!abTabId){
			cmdStatus = 'failed';
			birdType = 'failed';
      targetStatus = 'failed';
			
      console.log('background.js: no AB connection!');
			sendResponse({feedback: 'no_connection'});
		}
	
		else{
			cmdStatus = 'pending';//set command processing status to 'pending'
			birdType = 'pending';//set bird type status to pending
      targetStatus = 'pending';
			redundantCmdLock = true;
			
			sendMessageToContent(request);//forward message to content script
			sendResponse({feedback: "received command " + request.command});
		}
	}
});
 


