/*Heap sort
 *Retrieved from https://gist.github.com/Rosencrantz/1611286#file-heapsort-js
 */

function chunk(list,axis) {
    var chunks = [];
    for(var i=0; i<list.length; i++) {
        if(list.length % 2 == 1 && i+1 == list.length) {
        	chunks.push(list[i]);
        } else {
           	if(i % 2 == 0) {
				if(axis == 'x' || axis == 'X' ){
					if(list[i].x > list[i+1].x)	
						chunks.push(list[i]);
					else
						chunks.push(list[i+1]);
				}
				else if (axis == 'y' || axis == 'Y' ){
					if(list[i].y > list[i+1].y)	
						chunks.push(list[i]);
					else
						chunks.push(list[i+1]);
				}
			}
        }
    }
   
    return chunks; 
}
 
function bubble(list,axis) {
	var remainder = chunk(list,axis),
		heap = [list];
 
	heap.push(remainder);
	while(remainder.length != 1) {
		remainder = chunk(remainder,axis);
		heap.push(remainder);
	}
 
	return heap;
}
 
function getTopIndex(thing) {
	var currentIndex = 0,
		value = thing[thing.length-1][0],
		i = thing.length -2;
 
	while(i != -1) {
		if(!thing[i].length % 2 && currentIndex > 0) {
			currentIndex--;
		}
 
		if(thing[i][currentIndex + 1] == value) {
			currentIndex++;
			currentIndex = i ? currentIndex << 1 : currentIndex;
		} else if(currentIndex) {
					currentIndex = i ? currentIndex << 1 : currentIndex;
 
		}
			
		i--;
	}
 
	return currentIndex;
}
 
function heapSort(list, axis) {
	var sortedList = [],
		listCopy = list,
		heap = []
		targetLength = list.length;
 
	while(sortedList.length != targetLength) {
		heap = bubble(listCopy,axis);
		sortedList.push(heap[heap.length-1][0]);
		listCopy.splice(getTopIndex(heap), 1);
	}		
 
	return sortedList;
}
 