var canvas;
var context;
var img;
var canvasWidth;
var canvasHeight;
var bkg = chrome.extension.getBackgroundPage();


function testTraj(){

	img = new Image();
	var canvas;

	img.onload = function(){
		document.body.style.width = '840px';
		document.body.style.height = '480px';
		
		if(canvas == null){
		
			canvas = document.createElement('canvas');

			canvas.id = "gameImg";
			canvas.width = 840;
			canvas.height = 480;
			canvas.style.zIndex = 8;
			canvas.style.position = "absolute";
			canvas.style.border = "1px solid";
	
			var body = document.getElementsByTagName("body")[0];
			body.appendChild(canvas);

			gameImg = document.getElementById("gameImg");
			context = gameImg.getContext('2d');
		}	
		context.clearRect (0, 0, 840, 480);
		
		context.drawImage(img,0,0); //with offset 0,0
		var colour = context.getImageData(0, 0, img.width, img.height).data;
		var vision = new bkg.Vision(colour, img.width, img.height);
		var sling = vision.findSlingshotMBR();

    var scene = new Array();
    //compress rgb with first 3 bits					
    for (var y = 0; y < canvas.height; y++) {
      scene[y]= new Array();
      for (var x = 0; x < canvas.width; x++) {
        
        //offset for getting correct pixel
        var offset = (x + canvas.width * y) * 4;
        
        scene[y][x] =  ((colour[offset] & 0xe0) << 1) |
         ((colour[offset + 1] & 0xe0) >> 2) |
         ((colour[offset + 2] & 0xe0) >> 5);
        
      }
    }
      
    
		var woodObjs = vision.findWood();
		var stoneObjs = vision.findStones();
		var iceObjs = vision.findIce();
		var pigs = vision.findPigs();
		var redBirds = vision.findRedBirds();
		var yellowBirds = vision.findYellowBirds();
		var blueBirds = vision.findBlueBirds();
		var whiteBirds = vision.findWhiteBirds();
		var blackBirds = vision.findBlackBirds();

		drawMBRs(woodObjs, 'yellow');
		drawMBRs(stoneObjs, 'white');
		drawMBRs(iceObjs, 'blue');
		drawMBRs(pigs, 'green');
		drawMBRs(redBirds, 'red');
		drawMBRs(yellowBirds, 'yellow');
		drawMBRs(blueBirds, 'blue');
		drawMBRs(whiteBirds, 'white');
		drawMBRs(blackBirds, 'black');
		
		console.log('popup.js: found sling shot: ' + sling);

		drawMBR(sling, 'brown');

		canvas.addEventListener('mousemove', function(evt) {
			var mousePos = getMousePos(canvas, evt);
			var message = 'Mouse position: ' + mousePos.x + ',' + mousePos.y + "\n 15bit RBG: " + scene[mousePos.y][mousePos.x];
			writeMessage(message);
		}, false);		
		
		function writeMessage(message) {	
			context.clearRect(0, 0, 500, 30);		
			context.font = '15pt Calibri';
			context.fillStyle = 'black';
			context.fillText(message, 10, 25);
		}
		function getMousePos(canvas, evt) {
			var rect = canvas.getBoundingClientRect();
			return {
			  x: evt.clientX - rect.left,
			  y: evt.clientY - rect.top
			};
		}

		
		//var traj = 'low';
		//var tpt = new bkg.Point(420,240);
		var tpt = bkg.targetPt;
		console.log("target is " + tpt.x + "," + tpt.y);
		
		if(tpt != null){
			var tp = new bkg.trajectoryPlanner();
			
			var pts = tp.estimateLaunchPoint(sling, tpt);
			//console.log("pts length: " + pts.length + " " +pts[1].x+' ' +pts[1].y);
			//
			if(bkg.trajectory == 'high' && pts.length > 1){
				tp.plotTrajectory(context, sling, pts[1]);
			}
			
			else if(bkg.trajectory == 'low'){
				tp.plotTrajectory(context, sling, pts[0]);
			}	
			drawMBR(new bkg.Rectangle(tpt.x,tpt.y,5,5),'black')
		}
	};

	chrome.tabs.sendMessage(bkg.abTabId, {command:"screenshot"}, function(response) {
		console.log('popup.js: response from content script ' + response.data);
		var imageStr = response.data;
		img.src = imageStr;
	});	

	
	
}	
	
function liveGame(){
	img = new Image();
	var canvas;

	img.onload = function(){
		if(canvas == null){
		
			canvas = document.createElement('canvas');

			canvas.id = "gameImg";
			canvas.width = 840;
			canvas.height = 480;
			canvas.style.zIndex = 8;
			canvas.style.position = "absolute";
			canvas.style.border = "1px solid";
			
			var container = document.getElementsByTagName("canvas_container")[0];
			container.appendChild(canvas);

			gameImg = document.getElementById("gameImg");
			context = gameImg.getContext('2d');
		}	
		context.clearRect (0, 0, 840, 480);
		
		context.drawImage(img,0,0); //with offset 0,0
		var colour = context.getImageData(0, 0, img.width, img.height).data;
		console.log('popup.js: colour array set ' + colour[0]);
		var vision = new bkg.Vision(colour, img.width, img.height);
		console.log('popup.js: vision initated');
		var woodObjs = vision.findWood();
		var stoneObjs = vision.findStones();
		var iceObjs = vision.findIce();
		var sling = vision.findSlingshotMBR();
		var pigs = vision.findPigs();
		var redBirds = vision.findRedBirds();
		
		console.log('popup.js: found sling shot: ' + sling);
		drawMBRs(woodObjs, 'yellow');
		drawMBRs(stoneObjs, 'white');
		drawMBRs(iceObjs, 'blue');
		drawMBR(sling, 'brown');
		drawMBRs(pigs, 'green');
		drawMBRs(redBirds, 'red');
	};

	chrome.tabs.sendMessage(bkg.abTabId, {command:"screenshot"}, function(response) {
		console.log('popup.js: response from content script ' + response.data);
		var imageStr = response.data;
		img.src = imageStr;
	});	

}

function drawMBRs(objs,colour){
	for(var i = 0; i < objs.length; i ++){
		var mbr = objs[i];
		context.beginPath();
		context.lineWidth="2";
		context.strokeStyle= colour;
		context.rect(mbr.x,mbr.y,mbr.width,mbr.height);
		context.stroke();
	}

}

function drawMBR(mbr,colour){
	if(mbr != null){
		context.beginPath();
		context.lineWidth="2";
		context.strokeStyle= colour;
		context.rect(mbr.x,mbr.y,mbr.width,mbr.height);
		context.stroke();
	}
}

function openAB(){
	var abUrl = "http://chrome.angrybirds.com";
	chrome.windows.create({ url: abUrl });
}

function openSnap(){
	var snapUrl = "http://aibirds.org/bootcamp/SnapOffline/snap.html#open:http://aibirds.org/bootcamp/SnapOffline/ab_template.xml";
	//var snapUrl = "popup.html";
	chrome.windows.create({ url: snapUrl });
}

function changeLevel(){
	var level = prompt("Set current level to ", "1");
	if (level != null && level > 0 && bkg != null) {
		bkg.currentLevel = level;
		console.log('set level to ' + level);
	}
	else if(!bkg){
		console.log('bkg is null');
	}
}

window.onload = function(){

	document.getElementById('opensnap').onclick = openSnap;
	document.getElementById('openab').onclick = openAB;
	document.getElementById('changelevel').onclick = changeLevel;
	if(bkg.abTabId != null){
		testTraj();
	}
	
	//var newURL = "SnapOffline/snap.html";
	//chrome.tabs.create({ url: newURL });
	//liveGame();

}
//document.addEventListener('DOMContentLoaded', liveGame());