/*****************************************************************************
** ANGRYBIRDS AI AGENT FRAMEWORK
** Copyright (c) 2013, Sahan Abeyasinghe, XiaoYu (Gary) Ge, Stephen Gould,
** Jim Keys, Kar-Wai Lim, Jochen Renz
** All rights reserved.
**
** This software is distributed under terms of the BSD license. See the 
** LICENSE file in the root directory for details.
*****************************************************************************/
var debugCanvas;
var btnContainer;
var setLevelbutton;
var debugModeCB;
console.log('triggered by chrome angry birds');
//drawTraj();

window.onbeforeunload = function() {
	chrome.runtime.sendMessage({command:"angrybirds closed"});
}

window.onload = function(){
	//createSetLevelButton();
	//createDebugCheckBox();
	chrome.runtime.sendMessage({command: "angrybirds actived"}, function(response) {
	  console.log('connected with background');
	});
}
//auto switch to sd mode
if(!isSDActive()){
	location.href="javascript:switchVersion(true); void 0";
	console.log("switched to sd mode");
}
else{
	console.log("stay in sd mode");
}

function getOS(){
	var OSName="Unknown OS";
	if (navigator.appVersion.indexOf("Win")!=-1) OSName="Windows";
	if (navigator.appVersion.indexOf("Mac")!=-1) OSName="MacOS";
	if (navigator.appVersion.indexOf("X11")!=-1) OSName="UNIX";
	if (navigator.appVersion.indexOf("Linux")!=-1) OSName="Linux";
	return OSName;
}

//test if sd mode is active
function isSDActive() {
	if(document.getElementById("sdActive") != null){
		console.log('sd mode is active');
		return true;
	}
	else{
		console.log('hd mode is active');
		return false;
	}
}
//listen to the command from background.js
chrome.runtime.onMessage.addListener(
  function(request, sender, sendResponse) {
	var response;
  
    console.log(sender.tab ?
                "from a content script:" + sender.tab.url + " : " + request.command :
                "from the extension" + " : " + request.command );
	if(request.command == 'screenshot'){
		response = screenshot();
	}
	
	else if(request.command == 'click'){
		click(request.data);
		response = {data : 'clicked at ' + request.data.x + ',' + request.data.y};
	}
	
	else if(request.command == 'mousewheel'){
		mousewheel(request.data);
		response = {data : 'mousewheel ' + request.data.delta};
	}
	
	else if(request.command == 'drag'){
		drag(request.data);
		//response = {data : 'clicked at ' + request.data.x + ',' + request.data.y};
	}
	
    sendResponse(response);
});


// define supported message handlers
var handlers = {
	'click': click,
	'drag': drag,
	'mousewheel': mousewheel,
	'screenshot': screenshot
};

// generate a mouse click event
function click(data) {
	var x = data['x'];
	var y = data['y'];
	
	console.warn('clicked at ' + x + ' ' + y);
	
	var canvas = $('canvas');
	var offset = canvas.offset();
	x = offset.left + x;
	y = offset.top + y;
	
	var evt = document.createEvent('MouseEvent');
	evt.initMouseEvent('mousedown', true, true, window, 1, 0, 0, x, y, false, false, false, false, 0, null);
	canvas[0].dispatchEvent(evt);
	
	evt = document.createEvent('MouseEvent');
	evt.initMouseEvent('mouseup', true, true, window, 1, 0, 0, x, y, false, false, false, false, 0, null);
	canvas[0].dispatchEvent(evt);
}

// generate a mouse drag event
function drag(data) {
	var x = data['x'];
	var y = data['y'];
	var dx = data['dx'];
	var dy = data['dy'];
	
	var canvas = $('canvas');
	var offset = canvas.offset();
	x = offset.left + x;
	y = offset.top + y;
	dx = x + dx;
	dy = y + dy;
	
	var evt = document.createEvent('MouseEvent');
	evt.initMouseEvent('mousedown', true, true, window, 1, 0, 0, x, y, false, false, false, false, 0, null);
	canvas[0].dispatchEvent(evt);
	
	evt = document.createEvent('MouseEvent');
	evt.initMouseEvent('mousemove', true, true, window, 0, 0, 0, dx, dy, false, false, false, false, 0, null);
	canvas[0].dispatchEvent(evt);
	
	evt = document.createEvent('MouseEvent');
	evt.initMouseEvent('mouseup', true, true, window, 1, 0, 0, dx, dy, false, false, false, false, 0, null);
	canvas[0].dispatchEvent(evt);
}

// generate a mouse wheel event
function mousewheel(data) {
	var delta = data['delta'];
	var canvas = $('canvas');
	//var evt = document.createEvent('WheelEvent');
	var eventInit = { deltaX: 0, deltaY: -delta*120 }
	var evt = new WheelEvent("mousewheel", eventInit);
	//evt.initWebKitWheelEvent(0, delta, window, 0, 0, 0, 0, false, false, false, false);
	canvas[0].dispatchEvent(evt);
}

// capture a screenshot and send it to the client
function screenshot() {
	// get the original canvas
	var srcCanvas = $('#playn-root canvas');
	
	// create a new canvas
	var canvas = $('<canvas />').attr('height', srcCanvas.height() + 'px').attr('width', srcCanvas.width() + 'px')[0];
	var context = canvas.getContext('2d');
	
	// copy the original canvas into the new canvas
	srcCanvas = srcCanvas[0];
	context.drawImage(srcCanvas, 0, 0);
	
	// obtain a png of the canvas
	var imageString = canvas.toDataURL();
	var canvasWidth = srcCanvas.width;
	var canvasHeight = srcCanvas.height;
	return {'data': imageString, 'time': new Date().getTime(), 'canvasWidth': canvasWidth, 'canvasHeight': canvasHeight };
}

function drawTraj(){
	// get the original canvas
	var gameDiv = document.getElementById("playn-root");

	debugCanvas = document.createElement('canvas');
	debugCanvas.id     = "CursorLayer";
	debugCanvas.width  = 842;
	debugCanvas.height = 480;
	debugCanvas.style.zIndex = 8;
	debugCanvas.style.position = "absolute";
	debugCanvas.style.border   = "1px solid";
	debugCanvas.style.left = 0 + "px";
	debugCanvas.style.top = 0 + "px";
	debugCanvas.addEventListener('click', function() {gameDiv.removeChild(debugCanvas);}, false);
	gameDiv.appendChild(debugCanvas);
	var contex = debugCanvas.getContext("2d");
	contex.fillStyle = "#FF0000";
	contex.fillRect(0,0,150,75);

	//timer = setInterval("container.redraw()", 10);
}



function createSetLevelButton(){
	var gamecont = document.getElementById("content");
	var offsets = gamecont.getBoundingClientRect();
	btnContainer = document.createElement('div');
	btnContainer.id = 'block';
	btnContainer.className = 'block';
	btnContainer.style.position = "absolute";
	btnContainer.style.left = gamecont.left;
	btnContainer.style.top = offsets.top;
	
	gamecont.insertBefore(btnContainer, gamecont.childNodes.item("gameDiv"));

	setLevelbutton = document.createElement("input");
    setLevelbutton.type = "button";
    setLevelbutton.value = "Change Current Level";
	setLevelbutton.style.position="absolute";
	//setLevelbutton.style.left = 0;
	//setLevelbutton.style.top = 0;

    setLevelbutton.onclick = function(){
		var level = prompt("Set current level to ", "1");
		if (level != null && level > 0) {
			chrome.runtime.sendMessage({command: "setLevel",level:level}, function(response) {
				console.log('set level to ' + level);
			});
		}
    }

    btnContainer.appendChild(setLevelbutton);
}

function createDebugCheckBox(){
	debugModeCB = document.createElement('input');
	debugModeCB.type = "checkbox";
	debugModeCB.name = "debugCB";
	debugModeCB.value = "debugging";
	debugModeCB.id = "debugCB";
	var label = document.createElement('label')
	label.htmlFor = "debugLabel";
	label.appendChild(document.createTextNode('Enable debug mode'));

	btnContainer.appendChild(debugModeCB);
	btnContainer.appendChild(label);
}



